<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="m-4">

  <div
    id="layerManagementTitle"
    class="h4"
    [innerText]="messages.LAYER_MANAGEMENT"></div>

  <div class="pt-3 d-flex align-items-start">

    <button
      ls-button
      (click)="openEditLayerPopup()"
      [icon]="commonIcons.CREATE_ICON"
      [text]="messages.LAYER_CREATE"
      [disabled]="!tenantId">
    </button>

    <span class="flex-grow-1"></span>
    <span
      class="p-1 px-2"
      [innerText]="commonMessages.PAGINATION_SIZE_LABEL">
    </span>

    <ngb-pagination
      size="sm"
      [collectionSize]="pageSizes.length"
      [(page)]="pageSizeIndex"
      [pageSize]="1"
      [rotate]="false"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="refreshLayerList()">
      <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
    </ngb-pagination>

  </div>

  <!-- List -->

  <table
    aria-labelledby="layerManagementTitle"
    class="mt-3 bg-white table table-fixed table-striped table-borderless border shadow-sm">

    <thead class="border">
      <tr>
        <th
          *ngIf="userPreferences.showAdminIds"
          (click)="onRowOrderClicked(sortByEnum.Id)"
          class="th-sm col-id-fixed-size"
          scope="col">
          <fa-icon
            class="{{ sortBy === sortByEnum.Id ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUpIcon : caretDownIcon"
            [fixedWidth]="true"></fa-icon>
          {{ commonMessages.ID }}
        </th>
        <th
          class="th-sm"
          scope="col"
          (click)="onRowOrderClicked(sortByEnum.Name)">
          <fa-icon
            class="{{ sortBy === sortByEnum.Name ? 'visible' : 'invisible' }}"
            [icon]="asc ? caretUpIcon : caretDownIcon"
            [fixedWidth]="true">
          </fa-icon>
          {{ commonMessages.NAME }}
        </th>
        <th
          class="th-sm col-buttons-fixed-size"
          scope="col"
          [innerText]="commonMessages.ACTIONS"></th>
      </tr>
    </thead>
    <tbody
      app-list-loader
      [data]="layerList"
      [loading]="loading"
      [colspan]="colspan"
      [emptyMessage]="commonMessages.EMPTY_LAYER_LIST">
    </tbody>
    <tbody>
      <tr *ngFor="let layer of layerList">
        <td *ngIf="userPreferences.showAdminIds">
          <span class="sortable-row font-monospace text-size-small">{{ layer.id | namePipe }}</span>
        </td>
        <td><span class="sortable-row">{{ layer.name | namePipe }}</span></td>
        <td>
          <button
            type="button"
            class="btn btn-sm btn-outline-primary"
            [title]="commonMessages.EDIT"
            (click)="openEditLayerPopup(layer)">
            <fa-icon [icon]="commonIcons.EDIT_ICON"></fa-icon>
          </button>
          <button
            type="button"
            class="btn btn-sm btn-outline-danger ms-2"
            [title]="commonMessages.DELETE"
            (click)="onDeleteButtonClicked(layer)">
            <fa-icon [icon]="commonIcons.DELETE_ICON"></fa-icon>
          </button>
        </td>
      </tr>
    </tbody>
  </table>

  <ngb-pagination
    class="d-flex justify-content-end"
    size="sm"
    [collectionSize]="total"
    [pageSize]="getPageSize(pageSizeIndex)"
    [(page)]="page"
    [maxSize]="5"
    [rotate]="true"
    [boundaryLinks]="false"
    [directionLinks]="false"
    (pageChange)="refreshLayerList()">
  </ngb-pagination>

</div>
